 package com.huimv.manager.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.huimv.manager.entity.EartagDataEntity;
import com.huimv.manager.result.RRException;
import com.huimv.manager.service.EartagDataService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import com.huimv.manager.entity.CollectorRegisterEntity;
import com.huimv.manager.service.CollectorRegisterService;
import com.huimv.manager.result.R;
import com.huimv.manager.utils.PageUtils;


/**
 * 
 *
 * @author yinhao
 * @version ${version}
 * @date 2021-07-24 16:29:33
 */
@RestController
@RequestMapping("manager/collectorregister")
@CrossOrigin
public class CollectorRegisterController {
    @Autowired
    private CollectorRegisterService collectorRegisterService;
    @Autowired
    private EartagDataService eartagDataService;

    /**
     * 列表
     */
    @RequestMapping("/list")
    public R list(@RequestParam Map<String, Object> params){
        PageUtils page = collectorRegisterService.queryPage(params);

        return R.ok().put("page", page);
    }




    /**
     * 信息
     */
    @RequestMapping("/info/{id}")
    public R info(@PathVariable("id") Integer id){
		CollectorRegisterEntity collectorRegister = collectorRegisterService.getById(id);

        return R.ok().put("collectorRegister", collectorRegister);
    }

    /**
     * 保存
     */
    @RequestMapping("/save")
    public R save(@RequestBody CollectorRegisterEntity collectorRegister){
		collectorRegisterService.save(collectorRegister);

        return R.ok();
    }

    /**
     * 修改
     */
    @RequestMapping("/update")
    public R update(@RequestBody CollectorRegisterEntity collectorRegister){
		collectorRegisterService.updateById(collectorRegister);

        return R.ok();
    }

    /**
     * 删除
     */
    @RequestMapping("/delete")
    public R delete(@RequestBody Integer[] ids){

        if (ids == null || ids.length == 0){
            return R.error("未选择");
        }
        for (Integer id : ids) {
            CollectorRegisterEntity  collectorRegisterEntity= collectorRegisterService.getById(id);
            String deviceCode = collectorRegisterEntity.getDeviceCode();
            int count = eartagDataService.count(Wrappers.<EartagDataEntity>lambdaQuery().eq(EartagDataEntity::getDeviceCode, deviceCode));
            if (count >0){
                throw new RRException("删除失败,编号为"+deviceCode+"的设备有尚未清理的耳标");
            }
        }
		collectorRegisterService.removeByIds(Arrays.asList(ids));

        return R.ok();
    }

    /**
     * 统计设备状态
     */
    @RequestMapping("/countState")
    public R countState(@RequestParam Map<String, Object> params){
        Map map  = collectorRegisterService.countState(params);

        return R.ok().put("data", map);
    }



}
